%global gcc_branch 12
%undefine _auto_set_build_flags
# don't strip debuginfo from binaries for other platform, it does not work
%global __os_install_post %{nil}
%global debug_package %{nil}
%global _binaries_in_noarch_packages_terminate_build   0
%global _unpackaged_files_terminate_build 0

# will support powerpc64le loongarch64 riscv64 in short future
%global target_arch aarch64 x86_64 riscv64 loongarch64



Name: cross-toolchains
Version: 20240715
Release: 1%{?dist}
Summary: Binutils GCC and GLibc cross-toolchain
License: LGPL-2.1-or-later and LGPL-3.0-or-later and GPL-2.0-or-later and GPL-3.0-or-later and GPL-3.0-or-later with GCC-exception-3.1
URL:	 https://gitee.com/opencloudos-stream/cross-toolchains
Source1: README.md
ExclusiveArch: %{target_arch}
# using these four source codes
BuildRequires: gcc-source
BuildRequires: binutils-source
BuildRequires: glibc-source
BuildRequires: kernel-source
# using ccache to accelerate same software building in different arch
BuildRequires: ccache
BuildRequires: gcc, gcc-c++, binutils, make, python3, python3-devel, gettext, bison, texinfo, flex
BuildRequires: systemtap-sdt-devel, zlib-devel, sed, coreutils, dejagnu, glibc-static, sharutils, perl-podlators
# for binutils
BuildRequires: automake, autoconf, perl, chrpath, zlib-static, bc, libstdc++
# for gcc
BuildRequires: elfutils-devel >= 0.147, elfutils-libelf-devel >= 0.147
BuildRequires: glibc-devel >= 2.4.90-13, gdb, libzstd-devel
BuildRequires: gmp-devel >= 4.1.2-8, mpfr-devel >= 3.1.0, libmpc-devel >= 0.8.1
# for glibc
BuildRequires: procps-ng, util-linux, gawk
BuildRequires: audit-libs-devel >= 1.1.3, sed >= 3.95, libcap-devel, 
BuildRequires: coreutils, perl-Pod-Parser, findutils, libpng-devel, gd-devel, libselinux-devel
BuildRequires: diffutils, libstdc++-static, libidn2, perl-interpreter
# for kernel
BuildRequires: rsync
# for tests
%{expand:
%(/bin/bash -c "for arch in %{target_arch}; do
cat <<EOF
BuildRequires: /usr/bin/qemu-\${arch}-static
EOF
done")}



%description
cross-toolchain


##################################################################
# declared packages for architechtures in loop
##################################################################
%{expand:
%(/bin/bash -c "for arch in %{target_arch}; do
cat <<EOF

%package -n cross-toolchains-\${arch}
Summary: cross-toolchain for \${arch}
AutoReqProv: no
Requires: gcc-\${arch}-linux-gnu = %{version}-%{release}
Requires: gcc-libs-\${arch}-linux-gnu = %{version}-%{release}
Requires: gcc-\${arch}-static-linux-gnu = %{version}-%{release}
Requires: binutils-\${arch}-linux-gnu = %{version}-%{release}
Requires: glibc-\${arch}-linux-gnu = %{version}-%{release}
Requires: glibc-static-\${arch}-linux-gnu = %{version}-%{release}

%description -n cross-toolchains-\${arch}
meta package of cross-toolchains for \${arch}

%package -n gcc-\${arch}-linux-gnu
Summary: GCC cross-compiler for \${arch}
AutoReqProv: no
Provides: gcc-c++-\${arch}-linux-gnu = %{version}-%{release}
Provides: g++-\${arch}-linux-gnu = %{version}-%{release}
Requires: gcc-\${arch}-static-linux-gnu = %{version}-%{release}
Requires: gcc-libs-\${arch}-linux-gnu = %{version}-%{release}
Requires: binutils-\${arch}-linux-gnu = %{version}-%{release}
Requires: glibc-\${arch}-linux-gnu = %{version}-%{release}

%description -n gcc-\${arch}-linux-gnu
\${arch} GCC cross-compiler

%package -n gcc-libs-\${arch}-linux-gnu
Summary: \${arch}_arch-targeted GCC cross-compiler, target libraries
BuildArch: noarch
AutoReqProv: no

%description -n gcc-libs-\${arch}-linux-gnu
\${arch} GCC cross-compiler, shared libraries for target

%package -n gcc-\${arch}-static-linux-gnu
Summary: \${arch} GCC cross-compiler, static libraries
BuildArch: noarch
AutoReqProv: no

%description -n gcc-\${arch}-static-linux-gnu
\${arch} GCC cross-compiler, static libraries for target

%package -n binutils-\${arch}-linux-gnu
Summary: \${arch} binutils (linker, assembler, etc)
AutoReqProv: no

%description -n binutils-\${arch}-linux-gnu
\${arch} binutils (linker, assembler, objdump, etc)

%package -n glibc-\${arch}-linux-gnu
Summary: \${arch} cross-glibc
Requires: glibc-static-\${arch}-linux-gnu = %{version}-%{release}
BuildArch: noarch
AutoReqProv: no

%description -n glibc-\${arch}-linux-gnu
glibc for \${arch}_arch. Should be used for cross-compilation only

%package -n glibc-static-\${arch}-linux-gnu
Summary: \${arch} cross-glibc, static libraries
BuildArch: noarch
AutoReqProv: no

%description -n glibc-static-\${arch}-linux-gnu
static glibc for \${arch}. Should be used for cross-compilation only

EOF
done")}
##################################################################
# declared packages end
##################################################################



%prep
%setup -cT

rm -rf *

cp %{SOURCE1} .

mkdir -p -m755 linux binutils gcc glibc

tar axvf %{_usrsrc}/gcc/gcc-*.tar.xz -C gcc
tar axvf %{_usrsrc}/binutils/binutils-*.tar.xz -C binutils
tar axvf %{_usrsrc}/glibc/glibc-*.tar.xz -C glibc
tar axvf %{_usrsrc}/kernel/kernel-*.tar.xz -C linux
#find /usr/src/kernel/sources -type f -name 'kernel-source-*.tar' | xargs -I {} -n1 tar -x --strip-components=1 -f {} -C linux



%build
export CURRENT_DIR="%{_builddir}/%{name}-%{version}"

for TARGET_ARCH in %{target_arch};do
echo "--------------------------------------------------------------"
echo "starting building target ${TARGET_ARCH}"
echo "--------------------------------------------------------------"
cd "${CURRENT_DIR}"

TARGET=${TARGET_ARCH}-linux-gnu
SYSROOT=%{_prefix}/lib/${TARGET}/sys-root
save_PATH="${PATH}"

if [ "${TARGET_ARCH}" = "aarch64" ];then
	TARGET_KERNEL=arm64
	BINUTILS_OPT="--enable-gold=yes"
	GCC_BOOTSTRAP_OPT=""
	GLIBC_OPT=""
#	GLIBC_CFLAGS="-O2 -march=armv8.1-a"
	GLIBC_CFLAGS="-O2 -march=armv8-a"
	GCC_OPT=""
elif [ "${TARGET_ARCH}" = "riscv64" ];then
	TARGET_KERNEL=riscv
	BINUTILS_OPT="--enable-gold=no"
	GCC_BOOTSTRAP_OPT="--with-arch=rv64gc --with-abi=lp64d"
	GLIBC_OPT=""
	GLIBC_CFLAGS="-O2"
	GCC_OPT="--with-arch=rv64gc --with-abi=lp64d"
elif [ "${TARGET_ARCH}" = "loongarch64" ];then
	TARGET_KERNEL=loongarch
	BINUTILS_OPT="--enable-gold=no"
	GCC_BOOTSTRAP_OPT=""
	GLIBC_OPT="--disable-werror"
	GLIBC_CFLAGS="-O2 -march=loongarch64"
	GCC_OPT=""
elif [ "${TARGET_ARCH}" = "x86_64" ];then
	TARGET_KERNEL=x86
	BINUTILS_OPT="--enable-gold=yes"
	GCC_BOOTSTRAP_OPT=""
	GLIBC_OPT=""
	GLIBC_CFLAGS="-O2"
	GCC_OPT=""
else
	echo "cant support building cross-toolchains on your arch %_arch"
	exit 1
fi

mkdir -p "${CURRENT_DIR}/obj_${TARGET_ARCH}_binutils"
mkdir -p "${CURRENT_DIR}/obj_${TARGET_ARCH}_gcc"
mkdir -p "${CURRENT_DIR}/obj_${TARGET_ARCH}_gcc_bootstrap"
mkdir -p "${CURRENT_DIR}/obj_${TARGET_ARCH}_kheaders"
mkdir -p "${CURRENT_DIR}/obj_${TARGET_ARCH}_glibc"
mkdir -p -m755 "${CURRENT_DIR}/${TARGET_ARCH}_stage/usr/bin"
mkdir -p -m755 "${CURRENT_DIR}/${TARGET_ARCH}_stage1/usr/bin"

if [ -d "/usr/lib/ccache" ]; then
	export PATH="${CURRENT_DIR}/${TARGET_ARCH}_stage1/usr/bin":/usr/lib/ccache:"${PATH}"
else
	export PATH="${CURRENT_DIR}/${TARGET_ARCH}_stage1/usr/bin":"${PATH}"
fi
stagedir="${CURRENT_DIR}/${TARGET_ARCH}_stage"
stage1dir="${CURRENT_DIR}/${TARGET_ARCH}_stage1"


# installing kernel headers
# for all target architectures
make -j$(nproc) \
	-C linux \
	O="${CURRENT_DIR}/obj_${TARGET_ARCH}_kheaders" \
	ARCH="${TARGET_KERNEL}" \
	INSTALL_HDR_PATH="${stagedir}${SYSROOT}/usr" \
	headers_install


# building cross-binutils
# XXX: avoid %%configure for it puts $target libraries into /usr/lib64
pushd ${CURRENT_DIR}/obj_${TARGET_ARCH}_binutils
CC=gcc \
CXX=g++ \
CPP=cpp \
CFLAGS="-O2 -flto=auto -ffat-lto-objects -fexceptions -grecord-gcc-switches -pipe -Wall -Werror=format-security -Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS %{_hardening_gcc_cflags} -fstack-protector-strong -fasynchronous-unwind-tables -fstack-clash-protection" \
CXXFLAGS="-O2 -flto=auto -ffat-lto-objects -fexceptions -grecord-gcc-switches -pipe -Wall -Werror=format-security -Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS %{_hardening_gcc_cflags} -fstack-protector-strong -fasynchronous-unwind-tables -fstack-clash-protection" \
../binutils/configure ${BINUTILS_OPT} \
	--target=${TARGET} \
	--host=%{_target_platform} \
	--build=%{_target_platform} \
	--prefix=/usr \
	--disable-bootstrap \
	--disable-multiarch \
	--disable-multilib \
	--disable-werror \
	--disable-shared \
	--disable-nls \
	--with-sysroot=${SYSROOT} \
	--with-build-sysroot=${stagedir}${SYSROOT} \
	--with-system-zlib \
	--enable-plugins \
	--enable-ld=default \
	--enable-relro \
	--enable-textrel-check=warning

make -j$(nproc)
# XXX: avoid makeinstall for it puts $target libraries into /usr/lib64
make install DESTDIR=${stagedir}
# for bootstrap toolchain (to compile target glibc)
make install DESTDIR=${stage1dir}
popd


# bootstrap gcc (for compiling target glibc)
# not including g++ and libstdc++
pushd ${CURRENT_DIR}/obj_${TARGET_ARCH}_gcc_bootstrap
CC=gcc \
CXX=g++ \
CFLAGS="-O2 -flto=auto -ffat-lto-objects -fexceptions -grecord-gcc-switches -pipe -Wall -Wformat-security -Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS %{_hardening_gcc_cflags} -fstack-protector-strong  -fasynchronous-unwind-tables -fstack-clash-protection" \
CXXFLAGS="-O2 -flto=auto -ffat-lto-objects -grecord-gcc-switches -pipe -Wformat-security -Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS %{_hardening_gcc_cflags} -fstack-protector-strong -fasynchronous-unwind-tables -fstack-clash-protection" \
../gcc/configure ${GCC_BOOTSTRAP_OPT} \
	--target=${TARGET} \
	--host=%{_target_platform} \
	--build=%{_target_platform} \
	--prefix=%{_prefix} \
	--disable-bootstrap \
	--disable-multiarch \
	--disable-multilib \
	--disable-werror \
	--with-sysroot=${SYSROOT} \
	--with-build-sysroot=${stagedir}${SYSROOT} \
	--enable-languages=c \
	--with-newlib \
	--without-headers \
	--disable-nls \
	--disable-shared \
	--disable-threads \
	--disable-libsanitizer \
	--disable-libgomp \
	--disable-libitm \
	--disable-libquadmath \
	--disable-libsanitizer \
	--disable-libssp \
	--disable-libvtv \
	--disable-libatomic \
	--disable-libcilkrts \
	--enable-version-specific-runtime-libs \
	--with-gcc-major-version-only \
	--with-system-zlib \
	--enable-default-pie \
	--enable-gnu-unique-object \
	--enable-linker-build-id

make -j$(nproc) all-gcc all-target-libgcc
# XXX: avoid makeinstall for it puts $target libraries into /usr/lib64
make install-gcc install-target-libgcc DESTDIR=${stage1dir}
popd


# build cross-glibc
pushd ${CURRENT_DIR}/obj_${TARGET_ARCH}_glibc
# now we dont have cross-g++, but glibc will find g++ by default to build .cc,
# if it cannot find out cross-g++,it will select native g++, and this
# will cause building error, so we disable native g++ temply.
# it will use gcc only to build pure C glibc
ln -s /bin/false g++

# XXX: avoid %%configure since it puts target libraries/binaries into /usr/lib64
# Note: glibc's is a library, so $host must be the same as $target
PATH="${CURRENT_DIR}/obj_${TARGET_ARCH}_glibc":"${PATH}" \
CC=${TARGET_ARCH}-linux-gnu-gcc CXX=g++ CFLAGS=${GLIBC_CFLAGS} \
../glibc/configure ${GLIBC_OPT} \
	--host=${TARGET} \
	--target=${TARGET} \
	--build=%{_target_platform} \
	--prefix=%{_prefix} \
	--with-sysroot=${SYSROOT} \
	--with-build-sysroot=${stagedir}${SYSROOT} \
	--with-headers=${stagedir}${SYSROOT}/usr/include \
	--with-lib=${stagedir}${SYSROOT}/usr/lib \
	--disable-multilib \
	--disable-crypt \
	libc_cv_forced_unwind=yes

make -j$(nproc)
# XXX: avoid makeinstall since it puts target libs into /usr/lib64
# Note: target glibc **must** be installed into sysroot to prevent
# native compilers from using it by default
make install DESTDIR=${stagedir}${SYSROOT}
# XXX: gcc needs this to locate crt{1,i}.o
mkdir -p -m755 ${stagedir}${SYSROOT}/usr/lib

# Don't use bootstrap toolchain any more
export PATH="${stagedir}%{_prefix}/bin:${save_PATH}"
popd


# building complete gcc
pushd ${CURRENT_DIR}/obj_${TARGET_ARCH}_gcc

# XXX: avoid %%configure puts $target libraries in /usr/lib64

ac_cv_file__proc_self_exe=yes \
gcc_cv_libc_provides_ssp=yes \
../gcc/configure ${GCC_OPT} \
	--target=${TARGET} \
	--host=%{_target_platform} \
	--build=%{_target_platform} \
	--prefix=%{_prefix} \
	--disable-bootstrap \
	--disable-multiarch \
	--disable-multilib \
	--disable-werror \
	--with-sysroot=${SYSROOT} \
	--with-build-sysroot=${stagedir}${SYSROOT} \
	--with-gcc-major-version-only \
	--enable-languages=c,c++ \
	--enable-version-specific-runtime-libs \
	--disable-nls \
	--disable-libsanitizer \
	--with-system-zlib \
	--enable-default-pie \
	--enable-gnu-unique-object \
	--enable-linker-build-id


ac_cv_file__proc_self_exe=yes \
gcc_cv_libc_provides_ssp=yes \
make -j$(nproc)
# XXX: avoid makeinstall for it puts $target libraries into /usr/lib64
make install DESTDIR=${stagedir}
popd

# end building
# clear env
unset stagedir
unset stage1dir
unset PATH
export PATH=${save_PATH}
unset save_PATH

echo "--------------------------------------------------------------"
echo "end building target ${TARGET_ARCH}"
echo "--------------------------------------------------------------"
done



%install
export CURRENT_DIR="%{_builddir}/%{name}-%{version}"

for TARGET_ARCH in %{target_arch};do
echo "--------------------------------------------------------------"
echo "starting installing target ${TARGET_ARCH}"
echo "--------------------------------------------------------------"
cd "${CURRENT_DIR}"

TARGET=${TARGET_ARCH}-linux-gnu
SYSROOT=/usr/lib/${TARGET}/sys-root

save_PATH="${PATH}"
export PATH="${CURRENT_DIR}/${TARGET_ARCH}_stage/usr/bin":"${PATH}"

if [ "${TARGET_ARCH}" = "aarch64" ];then
	TARGET_KERNEL=arm64
	TARGET_LIBDIR=lib64
	TARGET_LD_LINUX=ld-linux-aarch64.so.1
elif [ "${TARGET_ARCH}" = "riscv64" ];then
	TARGET_KERNEL=riscv
	TARGET_LIBDIR=lib64
	TARGET_LD_LINUX=ld-linux-riscv64-lp64d.so.1
elif [ "${TARGET_ARCH}" = "loongarch64" ];then
	TARGET_KERNEL=loongarch
	TARGET_LIBDIR=lib64
	TARGET_LD_LINUX=ld-linux-loongarch-lp64d.so.1
elif [ "${TARGET_ARCH}" = "x86_64" ];then
	TARGET_KERNEL=x86
	TARGET_LIBDIR=lib64
	TARGET_LD_LINUX=ld-linux-x86-64.so.2
else
	echo "cant support building cross-toolchains on your arch %_arch"
	exit 1
fi


make -j$(nprocs) \
	-C linux \
	O="${CURRENT_DIR}/obj_${TARGET_ARCH}_kheaders" \
	ARCH=${TARGET_KERNEL} \
	INSTALL_HDR_PATH=%{buildroot}${SYSROOT}/usr \
	headers_install

# install cross-binutils

pushd obj_${TARGET_ARCH}_binutils

make install DESTDIR=%{buildroot} INSTALL="/usr/bin/install -p" tooldir="/usr/libexec/gcc/${TARGET}"

popd


# install cross-glibc
if [ "${TARGET_ARCH}" = "riscv64" ];then
for d in %{buildroot}${SYSROOT}%{_libdir} %{buildroot}${SYSROOT}/%{_lib}; do
        mkdir -p $d
        (cd $d && ln -sf . lp64d)
done
fi

pushd obj_${TARGET_ARCH}_glibc

make install DESTDIR=%{buildroot}${SYSROOT} INSTALL="/usr/bin/install -p"

popd


# install cross-gcc

pushd obj_${TARGET_ARCH}_gcc

make install DESTDIR=%{buildroot} INSTALL="/usr/bin/install -p"

popd


# relocate target libgcc_s
if [ -d "%{buildroot}/usr/lib/gcc/${TARGET}/lib64" ]; then
    mv %{buildroot}/usr/lib/gcc/${TARGET}/lib64/libgcc_s.so* %{buildroot}/usr/lib/gcc/${TARGET}/%{gcc_branch}/
    rmdir %{buildroot}/usr/lib/gcc/${TARGET}/lib64
fi

%{buildroot}/usr/bin/${TARGET}-gcc -dumpspecs > specs

if ["${TARGET_ARCH}" = "aarch64"];then
# XXX: native compiler sets /lib64/ld-linux-aarch64.so.1 as an ELF interpreter.
# Make sure cross-toolchain we build does the same thing.
sed -e "s;/lib/ld-linux-aarch64;/lib64/ld-linux-aarch64;g" -i specs
fi

if ["${TARGET_ARCH}" = "riscv64"];then
# XXX: native compiler sets /lib64/ld-linux-aarch64.so.1 as an ELF interpreter.
# Make sure cross-toolchain we build does the same thing.
sed -e "s;/lib/ld-linux-riscv;/lib64/ld-linux-riscv;g" -i specs
fi

# Assembler: %%target-as.
# Path is relative to %%{_prefix}/lib/gcc/%%target/%%{gcc_branch}
sed -e "/^[*]invoke_as:/,/^[*]cpp:/ s; as ; ../../../../bin/${TARGET}-as ;" -i specs
# objcopy: %%target-objcopy
sed -e "s; objcopy ; ../../../../bin/${TARGET}-objcopy ;" -i specs
install -m 644 specs %{buildroot}%{_prefix}/lib/gcc/${TARGET}/%{gcc_branch}/specs
# Note: collect2 (GCCs linker wrapper) searches for %%target-ld on its own.
# Alas it does not use relative paths and is not adjustable via the specs file

# XXX: apparently invoke_as: spec directive applies only to running assembler
# on compiler (cc1) output. The spec which describes compiling of `assembler`
# and `assembler-with-cpp` pseudo-languages seems to be hard-coded into GCC.
# As a result GCC still runs /usr/bin/as (instead of target assembler) when
# compiling .S files. Therefore install `as` symlinks in GCC libsubdir
# (%%{_prefix}/lib/gcc/%%target/%%{gcc_branch}).
# Just in a case make symlinks to other tools.
for tool in ar as ld ld.bfd ld.gold nm objcopy objdump ranlib readelf strip; do
    tool_path="%{buildroot}/usr/bin/${TARGET}-${tool}"
    [ -f "${tool_path}" ] || continue
    ln -sr "${tool_path}" %{buildroot}%{_prefix}/lib/gcc/${TARGET}/%{gcc_branch}/${tool}
    # just in a case add a symlink into libexec too
    ln -sr "${tool_path}" %{buildroot}%{_prefix}/libexec/gcc/${TARGET}/%{gcc_branch}/${tool}
done

if [ "${TARGET_LIBDIR}" = "lib64" ];then
# XXX: ABI: which is correct location of ELF interpreter for aarch64?
# Native glibc provides ld-linux-aarch64.so.1 in both /lib64 and /lib.
# Do the same thing in cross-glibc
echo "link the ld-linux-xxx.so.x"

if [ "${TARGET_ARCH}" = "aarch64" ] || [ "${TARGET_ARCH}" = "riscv64" ];then
ln -s ../lib/${TARGET_LD_LINUX} %{buildroot}${SYSROOT}/lib64/${TARGET_LD_LINUX}
else
ln -s ../../lib64/${TARGET_LD_LINUX} %{buildroot}${SYSROOT}/usr/lib64/${TARGET_LD_LINUX}
fi

fi

# remove runtime bits, not necessary for a cross-toolchain
rm -rf %{buildroot}${SYSROOT}/etc
rm -rf %{buildroot}${SYSROOT}/var
rm -rf %{buildroot}${SYSROOT}/sbin
rm -rf %{buildroot}${SYSROOT}/usr/share
rm -rf %{buildroot}${SYSROOT}/usr/bin
rm -rf %{buildroot}${SYSROOT}/usr/sbin
rm -rf %{buildroot}${SYSROOT}/usr/libexec
rm -rf %{buildroot}${SYSROOT}/usr/lib64/audit
rm -rf %{buildroot}${SYSROOT}/usr/lib64/gconv
rm -rf %{buildroot}/usr/share/info
rm -rf %{buildroot}/usr/share/man/man7
# python pretty-printers conflict with native compiler
rm -rf %{buildroot}/usr/share/gcc-%{gcc_branch}/python
# conflicts with the native compiler and is not particularly useful
rm -f %{buildroot}/usr/%_lib/libcc1.so*
# conflicts with the native bfd and is not particularly useful
rm -rf %{buildroot}/usr/lib/bfd-plugins
# Useless for Linux targets
rm -f %{buildroot}%_mandir/man1/${TARGET}-windmc*
rm -f %{buildroot}%_mandir/man1/${TARGET}-windres*
# libtool junk
find %{buildroot}%{_prefix}/lib/gcc/${TARGET}/%{gcc_branch} -type f -name '*.la' -delete
find %{buildroot}%{_prefix}/libexec/gcc -type f -name '*.la' -delete
# Target C++ runtime is used for linking only
find %{buildroot}%{_prefix}/lib/gcc/${TARGET}/%{gcc_branch} -type f -name 'lib*-gdb.py' -delete


# XXX: gcc needs this to locate crt1.o
install -d -m 755 %{buildroot}${SYSROOT}/usr/lib

# remove bootstrap toolchain
rm -rf "%{buildroot}/${TARGET_ARCH}_stage1"

rm -f %{buildroot}/usr/lib/gcc/${TARGET}/%{gcc_branch}/libssp.a
rm -f %{buildroot}/usr/lib/gcc/${TARGET}/%{gcc_branch}/libssp_nonshared.a
rm -f %{buildroot}/usr/lib/gcc/${TARGET}/%{gcc_branch}/libssp.so*

export PATH="${save_PATH}"
unset save_PATH

echo "--------------------------------------------------------------"
echo "end installing target ${TARGET_ARCH}"
echo "--------------------------------------------------------------"
done



%check
export CURRENT_DIR="%{_builddir}/%{name}-%{version}"

for TARGET_ARCH in %{target_arch};do
echo "--------------------------------------------------------------"
echo "starting check target ${TARGET_ARCH}"
echo "--------------------------------------------------------------"
cd "${CURRENT_DIR}"

TARGET=${TARGET_ARCH}-linux-gnu
SYSROOT=/usr/lib/${TARGET}/sys-root

cat > hello.c <<EOF
#include <stdio.h>
int main(int argc, char** argv) {
	printf("Hello, %%s!\n", argc > 1 ? argv[1] : "world");
	return 0;
}
EOF

cat > hello.cpp <<EOF
#include <iostream>
int main(int argc, char** argv) {
	std::cout << "Hello, " << (argc > 1 ? argv[1] : "world") << "!" << std::endl;
	return 0;
}
EOF

gcc_runtime_libdir=`dirname $(%{buildroot}/usr/bin/${TARGET}-gcc --print-libgcc-file-name)`

# XXX: PATH= is necessary for collect2 to find %%target-ld
PATH=%{buildroot}/usr/bin:$PATH \
%{buildroot}/usr/bin/${TARGET}-gcc -o hello_c hello.c || exit 2
PATH=%{buildroot}/usr/bin:$PATH \
%{buildroot}/usr/bin/${TARGET}-g++ -o hello_cpp hello.cpp || exit 3

# Note: LD_LIBRARY_PATH is for **target** ld.so.
# Use qemu-user-static so qemu-user is not affected by LD_LIBRARY_PATH
LD_LIBRARY_PATH=%{buildroot}${SYSROOT}/lib64:${gcc_runtime_libdir} \
	qemu-${TARGET_ARCH}-static -L %{buildroot}${SYSROOT} ./hello_c || exit 5

LD_LIBRARY_PATH=%{buildroot}${SYSROOT}/lib64:${gcc_runtime_libdir} \
	qemu-${TARGET_ARCH}-static -L %{buildroot}${SYSROOT} ./hello_cpp || exit 7

if [ "${TARGET_ARCH}" = "aarch64" ];then
cat > bye.S <<EOF
#include <sys/syscall.h>

	.arch armv8-a
	.data
message: .asciz "bye-bye ...\n"

	.text
	.align 2
	.global _start
_start:
	mov x8, __NR_write
	mov x0, 1
	adr x1, message
	mov x2, 12
	svc #0

	mov x8, __NR_exit
	mov x0, 0
	svc #0
	.section	.note.GNU-stack,"",@progbits
EOF

elif [ "${TARGET_ARCH}" = "riscv64" ];then
cat > bye.S <<EOF
#include <sys/syscall.h>

.text
.global _start
_start:
        addi a0, x0, 0
        addi a7, x0, __NR_exit
        ecall
EOF

elif [ "${TARGET_ARCH}" = "loongarch64" ];then
cat > bye.S <<EOF
#include <sys/syscall.h>

.data
message: .asciz "bye-bye ...\n"

.text
.global _start
_start:
	li.w \$a7, __NR_write
	li.w \$a0, 1 # stdout file descriptor
	la \$a1, message
	li.w \$a2, 12 # message length
	syscall 0x0

	li.w \$a7, __NR_exit
	li.w \$a0, 0
	syscall 0x0

.section	.note.GNU-stack,"",@progbits
EOF

elif [ "${TARGET_ARCH}" = "x86_64" ];then
cat > bye.S <<EOF
#include <sys/syscall.h>

.data
message: .asciz "bye-bye ...\n"
msg_len = (. - message)

.text
.global _start
_start:
	movl \$__NR_write, %%eax
	# stdout
	movl \$1, %%edi
	leaq message(%%rip), %%rsi
	movl \$msg_len, %%edx
	syscall

	movl \$__NR_exit, %%eax
	movl \$0, %%edi
	syscall

.section .note.GNU-stack,"",@progbits
EOF

else
echo "not support check for your arch %{_arch}"
fi

PATH=%{buildroot}/usr/bin:$PATH \
%{buildroot}/usr/bin/${TARGET}-gcc -static -nostdlib -o bye_asm bye.S || exit 11
qemu-${TARGET_ARCH}-static ./bye_asm || exit 13

done



#
# X86_64
#
%files -n cross-toolchains-x86_64
%doc README.md

%files -n gcc-x86_64-linux-gnu
%_bindir/x86_64-linux-gnu-gcc*
%_bindir/x86_64-linux-gnu-cpp
%_bindir/x86_64-linux-gnu-g++
%_bindir/x86_64-linux-gnu-c++
%_bindir/x86_64-linux-gnu-gcov*
%_bindir/x86_64-linux-gnu-lto*
%{_prefix}/lib/gcc/x86_64-linux-gnu/%{gcc_branch}/*
%{_prefix}/libexec/gcc/x86_64-linux-gnu/*
# avoid 'static library packaging violation' \"error\"
%exclude %{_prefix}/lib/gcc/x86_64-linux-gnu/%{gcc_branch}/libatomic.a
%exclude %{_prefix}/lib/gcc/x86_64-linux-gnu/%{gcc_branch}/libgcc.a
%exclude %{_prefix}/lib/gcc/x86_64-linux-gnu/%{gcc_branch}/libgcc_eh.a
%exclude %{_prefix}/lib/gcc/x86_64-linux-gnu/%{gcc_branch}/libgcov.a
%exclude %{_prefix}/lib/gcc/x86_64-linux-gnu/%{gcc_branch}/libgomp.a
%exclude %{_prefix}/lib/gcc/x86_64-linux-gnu/%{gcc_branch}/libstdc++.a
%exclude %{_prefix}/lib/gcc/x86_64-linux-gnu/%{gcc_branch}/libstdc++fs.a
%exclude %{_prefix}/lib/gcc/x86_64-linux-gnu/%{gcc_branch}/libsupc++.a
# avoid 'NEW bad_elf_symbols detected' \"error\"
%exclude %{_prefix}/lib/gcc/x86_64-linux-gnu/%{gcc_branch}/crt*.o
%exclude %{_prefix}/lib/gcc/x86_64-linux-gnu/%{gcc_branch}/libatomic.so*
%exclude %{_prefix}/lib/gcc/x86_64-linux-gnu/%{gcc_branch}/libgcc_s.so*
%exclude %{_prefix}/lib/gcc/x86_64-linux-gnu/%{gcc_branch}/libgomp.so*
%exclude %{_prefix}/lib/gcc/x86_64-linux-gnu/%{gcc_branch}/libitm.so*
%exclude %{_prefix}/lib/gcc/x86_64-linux-gnu/%{gcc_branch}/libitm.a
%exclude %{_prefix}/lib/gcc/x86_64-linux-gnu/%{gcc_branch}/libstdc++.so*
# binunitls
%exclude %{_prefix}/libexec/gcc/x86_64-linux-gnu/bin/*
%exclude %{_prefix}/libexec/gcc/x86_64-linux-gnu/lib/*
%_mandir/man1/x86_64-linux-gnu-cpp*
%_mandir/man1/x86_64-linux-gnu-g++*
%_mandir/man1/x86_64-linux-gnu-gcc*
%_mandir/man1/x86_64-linux-gnu-gcov*
%_mandir/man1/x86_64-linux-gnu-lto*

%files -n gcc-x86_64-static-linux-gnu
%{_prefix}/lib/gcc/x86_64-linux-gnu/%{gcc_branch}/libatomic.a
%{_prefix}/lib/gcc/x86_64-linux-gnu/%{gcc_branch}/libgcc.a
%{_prefix}/lib/gcc/x86_64-linux-gnu/%{gcc_branch}/libgcc_eh.a
%{_prefix}/lib/gcc/x86_64-linux-gnu/%{gcc_branch}/libgcov.a
%{_prefix}/lib/gcc/x86_64-linux-gnu/%{gcc_branch}/libgomp.a
%{_prefix}/lib/gcc/x86_64-linux-gnu/%{gcc_branch}/libitm.a
%{_prefix}/lib/gcc/x86_64-linux-gnu/%{gcc_branch}/libstdc++.a
%{_prefix}/lib/gcc/x86_64-linux-gnu/%{gcc_branch}/libstdc++fs.a
%{_prefix}/lib/gcc/x86_64-linux-gnu/%{gcc_branch}/libsupc++.a

%files -n gcc-libs-x86_64-linux-gnu
%{_prefix}/lib/gcc/x86_64-linux-gnu/%{gcc_branch}/crt*.o
%{_prefix}/lib/gcc/x86_64-linux-gnu/%{gcc_branch}/libatomic.so*
%{_prefix}/lib/gcc/x86_64-linux-gnu/%{gcc_branch}/libgcc_s.so*
%{_prefix}/lib/gcc/x86_64-linux-gnu/%{gcc_branch}/libgomp.so*
%{_prefix}/lib/gcc/x86_64-linux-gnu/%{gcc_branch}/libitm.so*
%{_prefix}/lib/gcc/x86_64-linux-gnu/%{gcc_branch}/libstdc++.so*

%files -n glibc-x86_64-linux-gnu
%{_prefix}/lib/x86_64-linux-gnu/sys-root/usr/include/*
# XXX: gcc needs %${SYSROOT}/usr/lib to locate C runtime (crt1.o)
%{_prefix}/lib/x86_64-linux-gnu/sys-root/lib64/*
%{_prefix}/lib/x86_64-linux-gnu/sys-root/usr/lib64/*
# Compatibility symlink to ld.so
%exclude %{_prefix}/lib/x86_64-linux-gnu/sys-root/usr/lib64/libBrokenLocale.a
%exclude %{_prefix}/lib/x86_64-linux-gnu/sys-root/usr/lib64/libanl.a
%exclude %{_prefix}/lib/x86_64-linux-gnu/sys-root/usr/lib64/libdl.a
%exclude %{_prefix}/lib/x86_64-linux-gnu/sys-root/usr/lib64/libm.a
%exclude %{_prefix}/lib/x86_64-linux-gnu/sys-root/usr/lib64/libpthread.a
%exclude %{_prefix}/lib/x86_64-linux-gnu/sys-root/usr/lib64/libresolv.a
%exclude %{_prefix}/lib/x86_64-linux-gnu/sys-root/usr/lib64/librt.a
%exclude %{_prefix}/lib/x86_64-linux-gnu/sys-root/usr/lib64/libutil.a

%files -n glibc-static-x86_64-linux-gnu
%{_prefix}/lib/x86_64-linux-gnu/sys-root/usr/lib64/libBrokenLocale.a
%{_prefix}/lib/x86_64-linux-gnu/sys-root/usr/lib64/libanl.a
%{_prefix}/lib/x86_64-linux-gnu/sys-root/usr/lib64/libdl.a
%{_prefix}/lib/x86_64-linux-gnu/sys-root/usr/lib64/libm.a
%{_prefix}/lib/x86_64-linux-gnu/sys-root/usr/lib64/libpthread.a
%{_prefix}/lib/x86_64-linux-gnu/sys-root/usr/lib64/libresolv.a
%{_prefix}/lib/x86_64-linux-gnu/sys-root/usr/lib64/librt.a
%{_prefix}/lib/x86_64-linux-gnu/sys-root/usr/lib64/libutil.a

%files -n binutils-x86_64-linux-gnu
%_bindir/x86_64-linux-gnu-addr2line
%_bindir/x86_64-linux-gnu-ar
%_bindir/x86_64-linux-gnu-as
%_bindir/x86_64-linux-gnu-c++filt
%_bindir/x86_64-linux-gnu-elfedit
%_bindir/x86_64-linux-gnu-gprof
%_bindir/x86_64-linux-gnu-ld
%_bindir/x86_64-linux-gnu-ld.bfd
%_bindir/x86_64-linux-gnu-nm
%_bindir/x86_64-linux-gnu-objcopy
%_bindir/x86_64-linux-gnu-objdump
%_bindir/x86_64-linux-gnu-ranlib
%_bindir/x86_64-linux-gnu-readelf
%_bindir/x86_64-linux-gnu-size
%_bindir/x86_64-linux-gnu-strings
%_bindir/x86_64-linux-gnu-strip
# gcc_tooldir
%{_prefix}/libexec/gcc/x86_64-linux-gnu/bin/*
%{_prefix}/libexec/gcc/x86_64-linux-gnu/lib/*
%_mandir/man1/x86_64-linux-gnu-addr2line*
%_mandir/man1/x86_64-linux-gnu-ar*
%_mandir/man1/x86_64-linux-gnu-as*
%_mandir/man1/x86_64-linux-gnu-c++filt*
%_mandir/man1/x86_64-linux-gnu-dlltool*
%_mandir/man1/x86_64-linux-gnu-elfedit*
%_mandir/man1/x86_64-linux-gnu-gprof*
%_mandir/man1/x86_64-linux-gnu-ld*
%_mandir/man1/x86_64-linux-gnu-nm*
%_mandir/man1/x86_64-linux-gnu-objcopy*
%_mandir/man1/x86_64-linux-gnu-objdump*
%_mandir/man1/x86_64-linux-gnu-ranlib*
%_mandir/man1/x86_64-linux-gnu-readelf*
%_mandir/man1/x86_64-linux-gnu-size*
%_mandir/man1/x86_64-linux-gnu-strings*
%_mandir/man1/x86_64-linux-gnu-strip*

#
# Aarch64
#
%files -n cross-toolchains-aarch64
%doc README.md

%files -n gcc-aarch64-linux-gnu
%_bindir/aarch64-linux-gnu-gcc*
%_bindir/aarch64-linux-gnu-cpp
%_bindir/aarch64-linux-gnu-g++
%_bindir/aarch64-linux-gnu-c++
%_bindir/aarch64-linux-gnu-gcov*
%_bindir/aarch64-linux-gnu-lto*
%{_prefix}/lib/gcc/aarch64-linux-gnu/%{gcc_branch}/*
%{_prefix}/libexec/gcc/aarch64-linux-gnu/*
# avoid 'static library packaging violation' \"error\"
%exclude %{_prefix}/lib/gcc/aarch64-linux-gnu/%{gcc_branch}/libatomic.a
%exclude %{_prefix}/lib/gcc/aarch64-linux-gnu/%{gcc_branch}/libgcc.a
%exclude %{_prefix}/lib/gcc/aarch64-linux-gnu/%{gcc_branch}/libgcc_eh.a
%exclude %{_prefix}/lib/gcc/aarch64-linux-gnu/%{gcc_branch}/libgcov.a
%exclude %{_prefix}/lib/gcc/aarch64-linux-gnu/%{gcc_branch}/libgomp.a
%exclude %{_prefix}/lib/gcc/aarch64-linux-gnu/%{gcc_branch}/libstdc++.a
%exclude %{_prefix}/lib/gcc/aarch64-linux-gnu/%{gcc_branch}/libstdc++fs.a
%exclude %{_prefix}/lib/gcc/aarch64-linux-gnu/%{gcc_branch}/libsupc++.a
# avoid 'NEW bad_elf_symbols detected' \"error\"
%exclude %{_prefix}/lib/gcc/aarch64-linux-gnu/%{gcc_branch}/crt*.o
%exclude %{_prefix}/lib/gcc/aarch64-linux-gnu/%{gcc_branch}/libatomic.so*
%exclude %{_prefix}/lib/gcc/aarch64-linux-gnu/%{gcc_branch}/libgcc_s.so*
%exclude %{_prefix}/lib/gcc/aarch64-linux-gnu/%{gcc_branch}/libgomp.so*
%exclude %{_prefix}/lib/gcc/aarch64-linux-gnu/%{gcc_branch}/libitm.so*
%exclude %{_prefix}/lib/gcc/aarch64-linux-gnu/%{gcc_branch}/libitm.a
%exclude %{_prefix}/lib/gcc/aarch64-linux-gnu/%{gcc_branch}/libstdc++.so*
# binunitls
%exclude %{_prefix}/libexec/gcc/aarch64-linux-gnu/bin/*
%exclude %{_prefix}/libexec/gcc/aarch64-linux-gnu/lib/*
%_mandir/man1/aarch64-linux-gnu-cpp*
%_mandir/man1/aarch64-linux-gnu-g++*
%_mandir/man1/aarch64-linux-gnu-gcc*
%_mandir/man1/aarch64-linux-gnu-gcov*
%_mandir/man1/aarch64-linux-gnu-lto*

%files -n gcc-aarch64-static-linux-gnu
%{_prefix}/lib/gcc/aarch64-linux-gnu/%{gcc_branch}/libatomic.a
%{_prefix}/lib/gcc/aarch64-linux-gnu/%{gcc_branch}/libgcc.a
%{_prefix}/lib/gcc/aarch64-linux-gnu/%{gcc_branch}/libgcc_eh.a
%{_prefix}/lib/gcc/aarch64-linux-gnu/%{gcc_branch}/libgcov.a
%{_prefix}/lib/gcc/aarch64-linux-gnu/%{gcc_branch}/libgomp.a
%{_prefix}/lib/gcc/aarch64-linux-gnu/%{gcc_branch}/libitm.a
%{_prefix}/lib/gcc/aarch64-linux-gnu/%{gcc_branch}/libstdc++.a
%{_prefix}/lib/gcc/aarch64-linux-gnu/%{gcc_branch}/libstdc++fs.a
%{_prefix}/lib/gcc/aarch64-linux-gnu/%{gcc_branch}/libsupc++.a

%files -n gcc-libs-aarch64-linux-gnu
%{_prefix}/lib/gcc/aarch64-linux-gnu/%{gcc_branch}/crt*.o
%{_prefix}/lib/gcc/aarch64-linux-gnu/%{gcc_branch}/libatomic.so*
%{_prefix}/lib/gcc/aarch64-linux-gnu/%{gcc_branch}/libgcc_s.so*
%{_prefix}/lib/gcc/aarch64-linux-gnu/%{gcc_branch}/libgomp.so*
%{_prefix}/lib/gcc/aarch64-linux-gnu/%{gcc_branch}/libitm.so*
%{_prefix}/lib/gcc/aarch64-linux-gnu/%{gcc_branch}/libstdc++.so*

%files -n glibc-aarch64-linux-gnu
%{_prefix}/lib/aarch64-linux-gnu/sys-root/usr/include/*
# XXX: gcc needs %${SYSROOT}/usr/lib to locate C runtime (crt1.o)
%dir %{_prefix}/lib/aarch64-linux-gnu/sys-root/usr/lib
%{_prefix}/lib/aarch64-linux-gnu/sys-root/lib64/*
%{_prefix}/lib/aarch64-linux-gnu/sys-root/usr/lib64/*
# Compatibility symlink to ld.so
%{_prefix}/lib/aarch64-linux-gnu/sys-root/lib/*
%exclude %{_prefix}/lib/aarch64-linux-gnu/sys-root/usr/lib64/libBrokenLocale.a
%exclude %{_prefix}/lib/aarch64-linux-gnu/sys-root/usr/lib64/libanl.a
%exclude %{_prefix}/lib/aarch64-linux-gnu/sys-root/usr/lib64/libdl.a
%exclude %{_prefix}/lib/aarch64-linux-gnu/sys-root/usr/lib64/libm.a
%exclude %{_prefix}/lib/aarch64-linux-gnu/sys-root/usr/lib64/libpthread.a
%exclude %{_prefix}/lib/aarch64-linux-gnu/sys-root/usr/lib64/libresolv.a
%exclude %{_prefix}/lib/aarch64-linux-gnu/sys-root/usr/lib64/librt.a
%exclude %{_prefix}/lib/aarch64-linux-gnu/sys-root/usr/lib64/libutil.a

%files -n glibc-static-aarch64-linux-gnu
%{_prefix}/lib/aarch64-linux-gnu/sys-root/usr/lib64/libBrokenLocale.a
%{_prefix}/lib/aarch64-linux-gnu/sys-root/usr/lib64/libanl.a
%{_prefix}/lib/aarch64-linux-gnu/sys-root/usr/lib64/libdl.a
%{_prefix}/lib/aarch64-linux-gnu/sys-root/usr/lib64/libm.a
%{_prefix}/lib/aarch64-linux-gnu/sys-root/usr/lib64/libpthread.a
%{_prefix}/lib/aarch64-linux-gnu/sys-root/usr/lib64/libresolv.a
%{_prefix}/lib/aarch64-linux-gnu/sys-root/usr/lib64/librt.a
%{_prefix}/lib/aarch64-linux-gnu/sys-root/usr/lib64/libutil.a

%files -n binutils-aarch64-linux-gnu
%_bindir/aarch64-linux-gnu-addr2line
%_bindir/aarch64-linux-gnu-ar
%_bindir/aarch64-linux-gnu-as
%_bindir/aarch64-linux-gnu-c++filt
%_bindir/aarch64-linux-gnu-dwp
%_bindir/aarch64-linux-gnu-elfedit
%_bindir/aarch64-linux-gnu-gprof
%_bindir/aarch64-linux-gnu-ld
%_bindir/aarch64-linux-gnu-ld.bfd
%_bindir/aarch64-linux-gnu-ld.gold
%_bindir/aarch64-linux-gnu-nm
%_bindir/aarch64-linux-gnu-objcopy
%_bindir/aarch64-linux-gnu-objdump
%_bindir/aarch64-linux-gnu-ranlib
%_bindir/aarch64-linux-gnu-readelf
%_bindir/aarch64-linux-gnu-size
%_bindir/aarch64-linux-gnu-strings
%_bindir/aarch64-linux-gnu-strip
# gcc_tooldir
%{_prefix}/libexec/gcc/aarch64-linux-gnu/bin/*
%{_prefix}/libexec/gcc/aarch64-linux-gnu/lib/*
%_mandir/man1/aarch64-linux-gnu-addr2line*
%_mandir/man1/aarch64-linux-gnu-ar*
%_mandir/man1/aarch64-linux-gnu-as*
%_mandir/man1/aarch64-linux-gnu-c++filt*
%_mandir/man1/aarch64-linux-gnu-dlltool*
%_mandir/man1/aarch64-linux-gnu-elfedit*
%_mandir/man1/aarch64-linux-gnu-gprof*
%_mandir/man1/aarch64-linux-gnu-ld*
%_mandir/man1/aarch64-linux-gnu-nm*
%_mandir/man1/aarch64-linux-gnu-objcopy*
%_mandir/man1/aarch64-linux-gnu-objdump*
%_mandir/man1/aarch64-linux-gnu-ranlib*
%_mandir/man1/aarch64-linux-gnu-readelf*
%_mandir/man1/aarch64-linux-gnu-size*
%_mandir/man1/aarch64-linux-gnu-strings*
%_mandir/man1/aarch64-linux-gnu-strip*

#
# loongarch64
#
%files -n cross-toolchains-loongarch64
%doc README.md

%files -n gcc-loongarch64-linux-gnu
%_bindir/loongarch64-linux-gnu-gcc*
%_bindir/loongarch64-linux-gnu-cpp
%_bindir/loongarch64-linux-gnu-g++
%_bindir/loongarch64-linux-gnu-c++
%_bindir/loongarch64-linux-gnu-gcov*
%_bindir/loongarch64-linux-gnu-lto*
%{_prefix}/lib/gcc/loongarch64-linux-gnu/%{gcc_branch}/*
%{_prefix}/libexec/gcc/loongarch64-linux-gnu/*
# avoid 'static library packaging violation' \"error\"
%exclude %{_prefix}/lib/gcc/loongarch64-linux-gnu/%{gcc_branch}/libatomic.a
%exclude %{_prefix}/lib/gcc/loongarch64-linux-gnu/%{gcc_branch}/libgcc.a
%exclude %{_prefix}/lib/gcc/loongarch64-linux-gnu/%{gcc_branch}/libgcc_eh.a
%exclude %{_prefix}/lib/gcc/loongarch64-linux-gnu/%{gcc_branch}/libgcov.a
%exclude %{_prefix}/lib/gcc/loongarch64-linux-gnu/%{gcc_branch}/libgomp.a
%exclude %{_prefix}/lib/gcc/loongarch64-linux-gnu/%{gcc_branch}/libstdc++.a
%exclude %{_prefix}/lib/gcc/loongarch64-linux-gnu/%{gcc_branch}/libstdc++fs.a
%exclude %{_prefix}/lib/gcc/loongarch64-linux-gnu/%{gcc_branch}/libsupc++.a
# avoid 'NEW bad_elf_symbols detected' \"error\"
%exclude %{_prefix}/lib/gcc/loongarch64-linux-gnu/%{gcc_branch}/crt*.o
%exclude %{_prefix}/lib/gcc/loongarch64-linux-gnu/%{gcc_branch}/libatomic.so*
%exclude %{_prefix}/lib/gcc/loongarch64-linux-gnu/%{gcc_branch}/libgcc_s.so*
%exclude %{_prefix}/lib/gcc/loongarch64-linux-gnu/%{gcc_branch}/libgomp.so*
%exclude %{_prefix}/lib/gcc/loongarch64-linux-gnu/%{gcc_branch}/libitm.so*
%exclude %{_prefix}/lib/gcc/loongarch64-linux-gnu/%{gcc_branch}/libitm.a
%exclude %{_prefix}/lib/gcc/loongarch64-linux-gnu/%{gcc_branch}/libstdc++.so*
# binunitls
%exclude %{_prefix}/libexec/gcc/loongarch64-linux-gnu/bin/*
%exclude %{_prefix}/libexec/gcc/loongarch64-linux-gnu/lib/*
%_mandir/man1/loongarch64-linux-gnu-cpp*
%_mandir/man1/loongarch64-linux-gnu-g++*
%_mandir/man1/loongarch64-linux-gnu-gcc*
%_mandir/man1/loongarch64-linux-gnu-gcov*
%_mandir/man1/loongarch64-linux-gnu-lto*

%files -n gcc-loongarch64-static-linux-gnu
%{_prefix}/lib/gcc/loongarch64-linux-gnu/%{gcc_branch}/libatomic.a
%{_prefix}/lib/gcc/loongarch64-linux-gnu/%{gcc_branch}/libgcc.a
%{_prefix}/lib/gcc/loongarch64-linux-gnu/%{gcc_branch}/libgcc_eh.a
%{_prefix}/lib/gcc/loongarch64-linux-gnu/%{gcc_branch}/libgcov.a
%{_prefix}/lib/gcc/loongarch64-linux-gnu/%{gcc_branch}/libgomp.a
%{_prefix}/lib/gcc/loongarch64-linux-gnu/%{gcc_branch}/libitm.a
%{_prefix}/lib/gcc/loongarch64-linux-gnu/%{gcc_branch}/libstdc++.a
%{_prefix}/lib/gcc/loongarch64-linux-gnu/%{gcc_branch}/libstdc++fs.a
%{_prefix}/lib/gcc/loongarch64-linux-gnu/%{gcc_branch}/libsupc++.a

%files -n gcc-libs-loongarch64-linux-gnu
%{_prefix}/lib/gcc/loongarch64-linux-gnu/%{gcc_branch}/crt*.o
%{_prefix}/lib/gcc/loongarch64-linux-gnu/%{gcc_branch}/libatomic.so*
%{_prefix}/lib/gcc/loongarch64-linux-gnu/%{gcc_branch}/libgcc_s.so*
%{_prefix}/lib/gcc/loongarch64-linux-gnu/%{gcc_branch}/libgomp.so*
%{_prefix}/lib/gcc/loongarch64-linux-gnu/%{gcc_branch}/libitm.so*
%{_prefix}/lib/gcc/loongarch64-linux-gnu/%{gcc_branch}/libstdc++.so*

%files -n glibc-loongarch64-linux-gnu
%{_prefix}/lib/loongarch64-linux-gnu/sys-root/usr/include/*
# XXX: gcc needs %${SYSROOT}/usr/lib to locate C runtime (crt1.o)
%{_prefix}/lib/loongarch64-linux-gnu/sys-root/lib64/*
%{_prefix}/lib/loongarch64-linux-gnu/sys-root/usr/lib64/*
%exclude %{_prefix}/lib/loongarch64-linux-gnu/sys-root/usr/lib64/libBrokenLocale.a
%exclude %{_prefix}/lib/loongarch64-linux-gnu/sys-root/usr/lib64/libdl.a
%exclude %{_prefix}/lib/loongarch64-linux-gnu/sys-root/usr/lib64/libm.a
%exclude %{_prefix}/lib/loongarch64-linux-gnu/sys-root/usr/lib64/libpthread.a
%exclude %{_prefix}/lib/loongarch64-linux-gnu/sys-root/usr/lib64/libresolv.a
%exclude %{_prefix}/lib/loongarch64-linux-gnu/sys-root/usr/lib64/librt.a
%exclude %{_prefix}/lib/loongarch64-linux-gnu/sys-root/usr/lib64/libutil.a

%files -n glibc-static-loongarch64-linux-gnu
%{_prefix}/lib/loongarch64-linux-gnu/sys-root/usr/lib64/libBrokenLocale.a
%{_prefix}/lib/loongarch64-linux-gnu/sys-root/usr/lib64/libdl.a
%{_prefix}/lib/loongarch64-linux-gnu/sys-root/usr/lib64/libm.a
%{_prefix}/lib/loongarch64-linux-gnu/sys-root/usr/lib64/libpthread.a
%{_prefix}/lib/loongarch64-linux-gnu/sys-root/usr/lib64/libresolv.a
%{_prefix}/lib/loongarch64-linux-gnu/sys-root/usr/lib64/librt.a
%{_prefix}/lib/loongarch64-linux-gnu/sys-root/usr/lib64/libutil.a

%files -n binutils-loongarch64-linux-gnu
%_bindir/loongarch64-linux-gnu-addr2line
%_bindir/loongarch64-linux-gnu-ar
%_bindir/loongarch64-linux-gnu-as
%_bindir/loongarch64-linux-gnu-c++filt
%_bindir/loongarch64-linux-gnu-elfedit
%_bindir/loongarch64-linux-gnu-gprof
%_bindir/loongarch64-linux-gnu-ld
%_bindir/loongarch64-linux-gnu-ld.bfd
%_bindir/loongarch64-linux-gnu-nm
%_bindir/loongarch64-linux-gnu-objcopy
%_bindir/loongarch64-linux-gnu-objdump
%_bindir/loongarch64-linux-gnu-ranlib
%_bindir/loongarch64-linux-gnu-readelf
%_bindir/loongarch64-linux-gnu-size
%_bindir/loongarch64-linux-gnu-strings
%_bindir/loongarch64-linux-gnu-strip
# gcc_tooldir
%{_prefix}/libexec/gcc/loongarch64-linux-gnu/bin/*
%{_prefix}/libexec/gcc/loongarch64-linux-gnu/lib/*
%_mandir/man1/loongarch64-linux-gnu-addr2line*
%_mandir/man1/loongarch64-linux-gnu-ar*
%_mandir/man1/loongarch64-linux-gnu-as*
%_mandir/man1/loongarch64-linux-gnu-c++filt*
%_mandir/man1/loongarch64-linux-gnu-dlltool*
%_mandir/man1/loongarch64-linux-gnu-elfedit*
%_mandir/man1/loongarch64-linux-gnu-gprof*
%_mandir/man1/loongarch64-linux-gnu-ld*
%_mandir/man1/loongarch64-linux-gnu-nm*
%_mandir/man1/loongarch64-linux-gnu-objcopy*
%_mandir/man1/loongarch64-linux-gnu-objdump*
%_mandir/man1/loongarch64-linux-gnu-ranlib*
%_mandir/man1/loongarch64-linux-gnu-readelf*
%_mandir/man1/loongarch64-linux-gnu-size*
%_mandir/man1/loongarch64-linux-gnu-strings*
%_mandir/man1/loongarch64-linux-gnu-strip*

#
# riscv64
#
%files -n cross-toolchains-riscv64
%doc README.md

%files -n gcc-riscv64-linux-gnu
%_bindir/riscv64-linux-gnu-gcc*
%_bindir/riscv64-linux-gnu-cpp
%_bindir/riscv64-linux-gnu-g++
%_bindir/riscv64-linux-gnu-c++
%_bindir/riscv64-linux-gnu-gcov*
%_bindir/riscv64-linux-gnu-lto*
%{_prefix}/lib/gcc/riscv64-linux-gnu/%{gcc_branch}/*
%{_prefix}/libexec/gcc/riscv64-linux-gnu/*
# avoid 'static library packaging violation' \"error\"
%exclude %{_prefix}/lib/gcc/riscv64-linux-gnu/%{gcc_branch}/libatomic.a
%exclude %{_prefix}/lib/gcc/riscv64-linux-gnu/%{gcc_branch}/libgcc.a
%exclude %{_prefix}/lib/gcc/riscv64-linux-gnu/%{gcc_branch}/libgcc_eh.a
%exclude %{_prefix}/lib/gcc/riscv64-linux-gnu/%{gcc_branch}/libgcov.a
%exclude %{_prefix}/lib/gcc/riscv64-linux-gnu/%{gcc_branch}/libgomp.a
%exclude %{_prefix}/lib/gcc/riscv64-linux-gnu/%{gcc_branch}/libstdc++.a
%exclude %{_prefix}/lib/gcc/riscv64-linux-gnu/%{gcc_branch}/libstdc++fs.a
%exclude %{_prefix}/lib/gcc/riscv64-linux-gnu/%{gcc_branch}/libsupc++.a
# avoid 'NEW bad_elf_symbols detected' \"error\"
%exclude %{_prefix}/lib/gcc/riscv64-linux-gnu/%{gcc_branch}/crt*.o
%exclude %{_prefix}/lib/gcc/riscv64-linux-gnu/%{gcc_branch}/libatomic.so*
%exclude %{_prefix}/lib/gcc/riscv64-linux-gnu/%{gcc_branch}/libgcc_s.so*
%exclude %{_prefix}/lib/gcc/riscv64-linux-gnu/%{gcc_branch}/libgomp.so*
%exclude %{_prefix}/lib/gcc/riscv64-linux-gnu/%{gcc_branch}/libstdc++.so*
# binunitls
%exclude %{_prefix}/libexec/gcc/riscv64-linux-gnu/bin/*
%exclude %{_prefix}/libexec/gcc/riscv64-linux-gnu/lib/*
%_mandir/man1/riscv64-linux-gnu-cpp*
%_mandir/man1/riscv64-linux-gnu-g++*
%_mandir/man1/riscv64-linux-gnu-gcc*
%_mandir/man1/riscv64-linux-gnu-gcov*
%_mandir/man1/riscv64-linux-gnu-lto*

%files -n gcc-riscv64-static-linux-gnu
%{_prefix}/lib/gcc/riscv64-linux-gnu/%{gcc_branch}/libatomic.a
%{_prefix}/lib/gcc/riscv64-linux-gnu/%{gcc_branch}/libgcc.a
%{_prefix}/lib/gcc/riscv64-linux-gnu/%{gcc_branch}/libgcc_eh.a
%{_prefix}/lib/gcc/riscv64-linux-gnu/%{gcc_branch}/libgcov.a
%{_prefix}/lib/gcc/riscv64-linux-gnu/%{gcc_branch}/libgomp.a
%{_prefix}/lib/gcc/riscv64-linux-gnu/%{gcc_branch}/libstdc++.a
%{_prefix}/lib/gcc/riscv64-linux-gnu/%{gcc_branch}/libstdc++fs.a
%{_prefix}/lib/gcc/riscv64-linux-gnu/%{gcc_branch}/libsupc++.a

%files -n gcc-libs-riscv64-linux-gnu
%{_prefix}/lib/gcc/riscv64-linux-gnu/%{gcc_branch}/crt*.o
%{_prefix}/lib/gcc/riscv64-linux-gnu/%{gcc_branch}/libatomic.so*
%{_prefix}/lib/gcc/riscv64-linux-gnu/%{gcc_branch}/libgcc_s.so*
%{_prefix}/lib/gcc/riscv64-linux-gnu/%{gcc_branch}/libgomp.so*
%{_prefix}/lib/gcc/riscv64-linux-gnu/%{gcc_branch}/libstdc++.so*

%files -n glibc-riscv64-linux-gnu
%{_prefix}/lib/riscv64-linux-gnu/sys-root/usr/include/*
# XXX: gcc needs %${SYSROOT}/usr/lib to locate C runtime (crt1.o)
%dir %{_prefix}/lib/riscv64-linux-gnu/sys-root/usr/lib
%{_prefix}/lib/riscv64-linux-gnu/sys-root/lib64/*
%{_prefix}/lib/riscv64-linux-gnu/sys-root/usr/lib64/*
# Compatibility symlink to ld.so
%{_prefix}/lib/riscv64-linux-gnu/sys-root/lib/*
%exclude %{_prefix}/lib/riscv64-linux-gnu/sys-root/usr/lib64/libBrokenLocale.a
%exclude %{_prefix}/lib/riscv64-linux-gnu/sys-root/usr/lib64/libanl.a
%exclude %{_prefix}/lib/riscv64-linux-gnu/sys-root/usr/lib64/libdl.a
%exclude %{_prefix}/lib/riscv64-linux-gnu/sys-root/usr/lib64/libm.a
%exclude %{_prefix}/lib/riscv64-linux-gnu/sys-root/usr/lib64/libpthread.a
%exclude %{_prefix}/lib/riscv64-linux-gnu/sys-root/usr/lib64/libresolv.a
%exclude %{_prefix}/lib/riscv64-linux-gnu/sys-root/usr/lib64/librt.a
%exclude %{_prefix}/lib/riscv64-linux-gnu/sys-root/usr/lib64/libutil.a

%files -n glibc-static-riscv64-linux-gnu
%{_prefix}/lib/loongarch64-linux-gnu/sys-root/usr/lib64/libBrokenLocale.a
%{_prefix}/lib/loongarch64-linux-gnu/sys-root/usr/lib64/libdl.a
%{_prefix}/lib/loongarch64-linux-gnu/sys-root/usr/lib64/libm.a
%{_prefix}/lib/loongarch64-linux-gnu/sys-root/usr/lib64/libpthread.a
%{_prefix}/lib/loongarch64-linux-gnu/sys-root/usr/lib64/libresolv.a
%{_prefix}/lib/loongarch64-linux-gnu/sys-root/usr/lib64/librt.a
%{_prefix}/lib/loongarch64-linux-gnu/sys-root/usr/lib64/libutil.a

%files -n binutils-riscv64-linux-gnu
%_bindir/riscv64-linux-gnu-addr2line
%_bindir/riscv64-linux-gnu-ar
%_bindir/riscv64-linux-gnu-as
%_bindir/riscv64-linux-gnu-c++filt
%_bindir/riscv64-linux-gnu-elfedit
%_bindir/riscv64-linux-gnu-gprof
%_bindir/riscv64-linux-gnu-ld
%_bindir/riscv64-linux-gnu-ld.bfd
%_bindir/riscv64-linux-gnu-nm
%_bindir/riscv64-linux-gnu-objcopy
%_bindir/riscv64-linux-gnu-objdump
%_bindir/riscv64-linux-gnu-ranlib
%_bindir/riscv64-linux-gnu-readelf
%_bindir/riscv64-linux-gnu-size
%_bindir/riscv64-linux-gnu-strings
%_bindir/riscv64-linux-gnu-strip
# gcc_tooldir
%{_prefix}/libexec/gcc/riscv64-linux-gnu/bin/*
%{_prefix}/libexec/gcc/riscv64-linux-gnu/lib/*
%_mandir/man1/riscv64-linux-gnu-addr2line*
%_mandir/man1/riscv64-linux-gnu-ar*
%_mandir/man1/riscv64-linux-gnu-as*
%_mandir/man1/riscv64-linux-gnu-c++filt*
%_mandir/man1/riscv64-linux-gnu-dlltool*
%_mandir/man1/riscv64-linux-gnu-elfedit*
%_mandir/man1/riscv64-linux-gnu-gprof*
%_mandir/man1/riscv64-linux-gnu-ld*
%_mandir/man1/riscv64-linux-gnu-nm*
%_mandir/man1/riscv64-linux-gnu-objcopy*
%_mandir/man1/riscv64-linux-gnu-objdump*
%_mandir/man1/riscv64-linux-gnu-ranlib*
%_mandir/man1/riscv64-linux-gnu-readelf*
%_mandir/man1/riscv64-linux-gnu-size*
%_mandir/man1/riscv64-linux-gnu-strings*
%_mandir/man1/riscv64-linux-gnu-strip*



%changelog
* Mon Jul 15 2024 Zhao Zhen <jeremiazhao@tencent.com> - 20240715-1
- added gcc-riscv64-static-linux-gnu
- added "-march=loongarch64" in loongarch64 which be the default arch
- added "-march=armv8-a" in aarch64 which be the default arch

* Mon Jul 08 2024 Zhao Zhen <jeremiazhao@tencent.com> - 20240624-1
- adaped for loongarch64

